## s390-tools 2.29.0

=== libekmfweb/Makefile ===
include ../common.mak

VERSION = 1.0
VERM = $(shell echo $(VERSION) | cut -d '.' -f 1)

ifneq (${HAVE_OPENSSL},0)
	ifneq (${HAVE_JSONC},0)
		ifneq (${HAVE_LIBCURL},0)
			BUILD_TARGETS += libekmfweb.so.$(VERSION)
			INSTALL_TARGETS += install-libekmfweb.so.$(VERSION)
		else
			BUILD_TARGETS += skip-libekmfweb-curl
			INSTALL_TARGETS += skip-libekmfweb-curl
		endif
	else
		BUILD_TARGETS += skip-libekmfweb-jsonc
		INSTALL_TARGETS += skip-libekmfweb-jsonc
	endif
else
	BUILD_TARGETS += skip-libekmfweb-openssl
	INSTALL_TARGETS += skip-libekmfweb-openssl
endif

libs = $(rootdir)/libseckey/libseckey.a

TMPFILE := $(shell mktemp)

detect-openssl-version.dep:
	echo "#include <openssl/opensslv.h>" > $(TMPFILE)
	echo "#include <openssl/evp.h>" >> $(TMPFILE)
	echo "#ifndef OPENSSL_VERSION_PREREQ" >> $(TMPFILE)
	echo "  #if defined(OPENSSL_VERSION_MAJOR) && defined(OPENSSL_VERSION_MINOR)" >> $(TMPFILE)
	echo "    #define OPENSSL_VERSION_PREREQ(maj, min) \\" >> $(TMPFILE)
	echo "                 ((OPENSSL_VERSION_MAJOR << 16) + \\" >> $(TMPFILE)
	echo "                  OPENSSL_VERSION_MINOR >= ((maj) << 16) + (min))" >> $(TMPFILE)
	echo "  #else" >> $(TMPFILE)
	echo "    #define OPENSSL_VERSION_PREREQ(maj, min) \\" >> $(TMPFILE)
	echo "                 (OPENSSL_VERSION_NUMBER >= (((maj) << 28) | \\" >> $(TMPFILE)
	echo "		        ((min) << 20)))" >> $(TMPFILE)
	echo "  #endif" >> $(TMPFILE)
	echo "#endif" >> $(TMPFILE)
	echo "#if !OPENSSL_VERSION_PREREQ(1, 1)" >> $(TMPFILE)
	echo "  #error openssl version 1.1 is required" >> $(TMPFILE)
	echo "#endif" >> $(TMPFILE)
	echo "static void __attribute__((unused)) test(void) {" >> $(TMPFILE)
	echo "    EVP_PKEY_meth_remove(NULL);" >> $(TMPFILE)
	echo "}" >> $(TMPFILE)
	mv $(TMPFILE) $@

CURL_CONFIG ?= curl-config

check-dep-libekmfweb: detect-openssl-version.dep
	$(call check_dep, \
		"libekmfweb", \
		"detect-openssl-version.dep", \
		"openssl-devel version >= 1.1.1", \
		"HAVE_OPENSSL=0", \
		-I. -lcrypto -DOPENSSL_SUPPRESS_DEPRECATED)
	$(call check_dep, \
		"libekmfweb", \
		"json-c/json.h", \
		"json-c-devel", \
		"HAVE_JSONC=0")
	$(call check_dep, \
		"libekmfweb", \
		"curl/curl.h", \
		"libcurl-devel", \
		"HAVE_LIBCURL=0" \
		`$(CURL_CONFIG) --cflags` `$(CURL_CONFIG) --libs`)
	$(CURL_CONFIG) --ssl-backends | grep OpenSSL >/dev/null 2>&1 || { echo "Error: libcurl is not built with the OpenSSL backend"; exit 1; }
	touch check-dep-libekmfweb

skip-libekmfweb-openssl:
	echo "  SKIP    libekmfweb due to HAVE_OPENSSL=0"

skip-libekmfweb-jsonc:
	echo "  SKIP    libekmfweb due to HAVE_JSONC=0"

skip-libekmfweb-curl:
	echo "  SKIP    libekmfweb due to HAVE_LIBCURL=0"

all: $(BUILD_TARGETS)

ekmfweb.o: check-dep-libekmfweb ekmfweb.c utilities.h cca.h $(rootdir)include/ekmfweb/ekmfweb.h
utilities.o: check-dep-libekmfweb utilities.c utilities.h $(rootdir)include/ekmfweb/ekmfweb.h
cca.o: check-dep-libekmfweb cca.c cca.h utilities.h $(rootdir)include/ekmfweb/ekmfweb.h

libekmfweb.so.$(VERSION): ALL_CFLAGS += -fPIC `$(CURL_CONFIG) --cflags`
libekmfweb.so.$(VERSION): LDLIBS = -ljson-c -lcrypto -lssl `$(CURL_CONFIG) --libs` -ldl
libekmfweb.so.$(VERSION): ALL_LDFLAGS += -shared -Wl,--version-script=libekmfweb.map \
	-Wl,-z,defs,-Bsymbolic -Wl,-soname,libekmfweb.so.$(VERM)
libekmfweb.so.$(VERSION): ekmfweb.o utilities.o cca.o $(libs)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@
	ln -srf libekmfweb.so.$(VERSION) libekmfweb.so.$(VERM)
	ln -srf libekmfweb.so.$(VERSION) libekmfweb.so

install-libekmfweb.so.$(VERSION): libekmfweb.so.$(VERSION)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 -T libekmfweb.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERSION)
	ln -srf $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERM)
	ln -srf $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRINCLUDEDIR)/ekmfweb
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 $(rootdir)include/ekmfweb/ekmfweb.h $(DESTDIR)$(USRINCLUDEDIR)/ekmfweb

install: all $(INSTALL_TARGETS)

clean:
	rm -f *.o libekmfweb.so* check-dep-libekmfweb detect-openssl-version.dep

.PHONY: all install clean skip-libekmfweb-openssl skip-libekmfweb-jsonc \
	skip-libekmfweb-curl install-libekmfweb.so.$(VERSION)

=== libkmipclient/Makefile ===
include ../common.mak

VERSION = 1.0
VERM = $(shell echo $(VERSION) | cut -d '.' -f 1)

ifneq (${HAVE_OPENSSL},0)
	ifneq (${HAVE_JSONC},0)
		ifneq (${HAVE_LIBXML2},0)
			ifneq (${HAVE_LIBCURL},0)
				BUILD_TARGETS += libkmipclient.so.$(VERSION)
				INSTALL_TARGETS += install-libkmipclient.so.$(VERSION)
			else
				BUILD_TARGETS += skip-libkmipclient-curl
				INSTALL_TARGETS += skip-libkmipclient-curl
			endif
		else
			BUILD_TARGETS += skip-libkmipclient-xml
			INSTALL_TARGETS += skip-libkmipclient-xml
		endif
	else
		BUILD_TARGETS += skip-libkmipclient-jsonc
		INSTALL_TARGETS += skip-libkmipclient-jsonc
	endif
else
	BUILD_TARGETS += skip-libkmipclient-openssl
	INSTALL_TARGETS += skip-libkmipclient-openssl
endif

TMPFILE := $(shell mktemp)

detect-openssl-version.dep:
	echo "#include <openssl/opensslv.h>" > $(TMPFILE)
	echo "#include <openssl/evp.h>" >> $(TMPFILE)
	echo "#ifndef OPENSSL_VERSION_PREREQ" >> $(TMPFILE)
	echo "  #if defined(OPENSSL_VERSION_MAJOR) && defined(OPENSSL_VERSION_MINOR)" >> $(TMPFILE)
	echo "    #define OPENSSL_VERSION_PREREQ(maj, min) \\" >> $(TMPFILE)
	echo "                 ((OPENSSL_VERSION_MAJOR << 16) + \\" >> $(TMPFILE)
	echo "                  OPENSSL_VERSION_MINOR >= ((maj) << 16) + (min))" >> $(TMPFILE)
	echo "  #else" >> $(TMPFILE)
	echo "    #define OPENSSL_VERSION_PREREQ(maj, min) \\" >> $(TMPFILE)
	echo "                 (OPENSSL_VERSION_NUMBER >= (((maj) << 28) | \\" >> $(TMPFILE)
	echo "		        ((min) << 20)))" >> $(TMPFILE)
	echo "  #endif" >> $(TMPFILE)
	echo "#endif" >> $(TMPFILE)
	echo "#if !OPENSSL_VERSION_PREREQ(1, 1)" >> $(TMPFILE)
	echo "  #error openssl version 1.1 is required" >> $(TMPFILE)
	echo "#endif" >> $(TMPFILE)
	echo "static void __attribute__((unused)) test(void) {" >> $(TMPFILE)
	echo "    EVP_PKEY_meth_remove(NULL);" >> $(TMPFILE)
	echo "}" >> $(TMPFILE)
	mv $(TMPFILE) $@

CURL_CONFIG ?= curl-config
XML2_CONFIG ?= xml2-config

check-dep-libkmipclient: detect-openssl-version.dep
	$(call check_dep, \
		"libkmipclient", \
		"detect-openssl-version.dep", \
		"openssl-devel version >= 1.1.1", \
		"HAVE_OPENSSL=0", \
		-I. -lcrypto -DOPENSSL_SUPPRESS_DEPRECATED)
	$(call check_dep, \
		"libkmipclient", \
		"json-c/json.h", \
		"json-c-devel", \
		"HAVE_JSONC=0")
	$(call check_dep, \
		"libkmipclient", \
		"libxml/tree.h", \
		"libxml2-devel", \
		"HAVE_LIBXML2=0", \
		`$(XML2_CONFIG) --cflags` `$(XML2_CONFIG) --libs`)
	$(call check_dep, \
		"libkmipclient", \
		"curl/curl.h", \
		"libcurl-devel", \
		"HAVE_LIBCURL=0" \
		`$(CURL_CONFIG) --cflags` `$(CURL_CONFIG) --libs`)
	$(CURL_CONFIG) --ssl-backends | grep OpenSSL >/dev/null 2>&1 || { echo "Error: libcurl is not built with the OpenSSL backend"; exit 1; }
	touch check-dep-libkmipclient

skip-libkmipclient-openssl:
	echo "  SKIP    libkmipclient due to HAVE_OPENSSL=0"

skip-libkmipclient-jsonc:
	echo "  SKIP    libkmipclient due to HAVE_JSONC=0"

skip-libkmipclient-xml:
	echo "  SKIP    libkmipclient due to HAVE_LIBXML2=0"

skip-libkmipclient-curl:
	echo "  SKIP    libkmipclient due to HAVE_LIBCURL=0"

all: $(BUILD_TARGETS)

kmip.o: check-dep-libkmipclient kmip.c kmip.h utils.h $(rootdir)include/kmipclient/kmipclient.h
request.o: check-dep-libkmipclient request.c kmip.h names.h $(rootdir)include/kmipclient/kmipclient.h
response.o: check-dep-libkmipclient response.c kmip.h names.h $(rootdir)include/kmipclient/kmipclient.h
attribute.o: check-dep-libkmipclient attribute.c kmip.h names.h $(rootdir)include/kmipclient/kmipclient.h
key.o: check-dep-libkmipclient key.c kmip.h names.h $(rootdir)include/kmipclient/kmipclient.h
ttlv.o: check-dep-libkmipclient ttlv.c kmip.h utils.h $(rootdir)include/kmipclient/kmipclient.h
json.o: check-dep-libkmipclient json.c kmip.h names.h utils.h $(rootdir)include/kmipclient/kmipclient.h
xml.o: check-dep-libkmipclient xml.c kmip.h names.h utils.h $(rootdir)include/kmipclient/kmipclient.h
https.o: check-dep-libkmipclient https.c kmip.h utils.h $(rootdir)include/kmipclient/kmipclient.h
tls.o: check-dep-libkmipclient tls.c kmip.h utils.h $(rootdir)include/kmipclient/kmipclient.h
names.o: check-dep-libkmipclient names.c names.h utils.h $(rootdir)include/kmipclient/kmipclient.h
utils.o: check-dep-libkmipclient utils.c names.h utils.h $(rootdir)include/kmipclient/kmipclient.h

libkmipclient.so.$(VERSION): ALL_CFLAGS += -fPIC `$(XML2_CONFIG) --cflags` `$(CURL_CONFIG) --cflags`
libkmipclient.so.$(VERSION): LDLIBS = -ljson-c -lcrypto -lssl `$(XML2_CONFIG) --libs` `$(CURL_CONFIG) --libs`
libkmipclient.so.$(VERSION): ALL_LDFLAGS += -shared -Wl,--version-script=libkmipclient.map \
	-Wl,-z,defs,-Bsymbolic -Wl,-soname,libkmipclient.so.$(VERM)
libkmipclient.so.$(VERSION): kmip.o request.o response.o attribute.o key.o ttlv.o json.o \
	xml.o https.o tls.o names.o utils.o
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@
	ln -srf libkmipclient.so.$(VERSION) libkmipclient.so.$(VERM)
	ln -srf libkmipclient.so.$(VERSION) libkmipclient.so

install-libkmipclient.so.$(VERSION): libkmipclient.so.$(VERSION)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 -T libkmipclient.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libkmipclient.so.$(VERSION)
	ln -srf $(DESTDIR)$(SOINSTALLDIR)/libkmipclient.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libkmipclient.so.$(VERM)
	ln -srf $(DESTDIR)$(SOINSTALLDIR)/libkmipclient.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libkmipclient.so
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRINCLUDEDIR)/kmipclient
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 $(rootdir)include/kmipclient/kmipclient.h $(DESTDIR)$(USRINCLUDEDIR)/kmipclient

install: all $(INSTALL_TARGETS)

clean:
	rm -f *.o libkmipclient.so* check-dep-libkmipclient detect-openssl-version.dep

.PHONY: all install clean skip-libkmipclient-openssl skip-libkmipclient-jsonc \
	skip-libkmipclient-xml skip-libkmipclient-curl install-libkmipclient.so.$(VERSION)

=== rust/Makefile ===
include ../common.mak
HAVE_CARGO ?= 1
HAVE_OPENSSL ?= 1
HAVE_LIBCURL ?= 1

INSTALL_TARGETS := skip-build
BUILD_TARGETS := skip-build
PV_BUILD_TARGETS := skip-pv-build
CARGO_TARGETS :=
PV_TARGETS :=
CARGO_TEST_TARGETS :=

ifneq (${HAVE_CARGO},0)
	CARGO_TARGETS :=

	BUILD_TARGETS = $(CARGO_TARGETS)
	INSTALL_TARGETS := install-rust-tools install-man
	CARGO_TEST_TARGETS = $(addsuffix, _test, $(CARGO_TARGETS))

ifneq (${HAVE_OPENSSL},0)
ifneq (${HAVE_LIBCURL},0)
	PV_TARGETS := pvsecret

	PV_BUILD_TARGETS = $(PV_TARGETS)
	CARGO_TEST_TARGETS += $(addsuffix, _test, $(PV_TARGETS)) pv
endif #LIBCURL
endif #OPENSSL
endif #CARGO

BUILD_TARGETS += $(PV_BUILD_TARGETS)

# build release targets by default
ifeq ("${D}","0")
	ALL_CARGOFLAGS += --release
endif

# the cc crate uses these variables to compile c code. It does not open a shell
# to call the compiler, so no echo etc. allowed here, just a path to a program
$(BUILD_TARGETS) rust-test: CC = $(CC_SILENT)
$(BUILD_TARGETS) rust-test: AR = $(AR_SILENT)

$(CARGO_TARGETS): .check-cargo .no-cross-compile
	$(CARGO_BUILD) --manifest-path=$@/Cargo.toml $(ALL_CARGOFLAGS)
.PHONY: $(CARGO_TARGETS)


$(CARGO_TEST_TARGETS): .check-cargo .no-cross-compile
	$(CARGO_TEST) --manifest-path=$@/Cargo.toml --all-features $(CARGOFLAGS)
.PHONY: $(CARGO_TEST_TARGETS)

$(PV_TARGETS): .check-cargo .no-cross-compile .check-dep-pvtools
	$(CARGO_BUILD) --manifest-path=$@/Cargo.toml $(ALL_CARGOFLAGS)
.PHONY: $(PV_TARGETS)

skip-build:
	echo "  SKIP    rust-tools due to unresolved dependencies"

skip-pv-build:
	echo "  SKIP    rust-pv-tools due to unresolved dependencies"

all: $(BUILD_TARGETS)
install: $(INSTALL_TARGETS)

print-rust-targets:
	echo $(BUILD_TARGETS)

clean:
	$(foreach target,$(CARGO_TARGETS),\
		$(CARGO_CLEAN) --manifest-path=$(target)/Cargo.toml ${ALL_CARGOFLAGS} ;)
	$(foreach target,$(PV_TARGETS),\
		$(CARGO_CLEAN) --manifest-path=$(target)/Cargo.toml ${CARGOFLAGS} ;)
	$(RM) -- .check-dep-pvtools .detect-openssl.dep.c .check-cargo

rust-test: .check-cargo .no-cross-compile
	$(foreach target,$(CARGO_TEST_TARGETS),\
		$(CARGO_TEST) --manifest-path=$(target)/Cargo.toml --all-features ${ALL_CARGOFLAGS} ;)

install-rust-tools: $(BUILD_TARGETS)
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
	$(foreach target,$(CARGO_TARGETS),\
		$(INSTALL) $(target)/target/release/$(target) $(DESTDIR)$(USRBINDIR);)
	$(foreach target,$(PV_TARGETS),\
		$(INSTALL) $(target)/target/release/$(target) $(DESTDIR)$(USRBINDIR);)

install-man:
	$(foreach target,$(CARGO_TARGETS),\
		$(INSTALL) -m 644 $(target)/man/*.1 -t $(DESTDIR)$(MANDIR)/man1;)
	$(foreach target,$(PV_TARGETS),\
		$(INSTALL) -m 644 $(target)/man/*.1 -t $(DESTDIR)$(MANDIR)/man1;)

.PHONY: all install clean skip-build install-rust-tools print-rust-targets install-man rust-test

.check-cargo:
ifeq ($(shell command -v $(CARGO)),)
	$(call check_dep, \
		"rust/cargo", \
		"invalid-incl", \
		"cargo", \
		"HAVE_CARGO=0")
endif
	touch $@

.no-cross-compile:
ifneq ($(HOST_ARCH), $(BUILD_ARCH))
	$(error Cross compiling is not supported for rust code. Specify HAVE_CARGO=0 to disable rust compilation)
endif
.PHONY: .no-cross-compile

.detect-openssl.dep.c:
	echo "#include <openssl/evp.h>" > $@
	echo "#if OPENSSL_VERSION_NUMBER < 0x10101000L" >> $@
	echo "  #error openssl version 1.1.1 is required" >> $@
	echo "#endif" >> $@
	echo "static void __attribute__((unused)) test(void) {" >> $@
	echo "    EVP_MD_CTX *ctx = EVP_MD_CTX_new();" >> $@
	echo "    EVP_MD_CTX_free(ctx);" >> $@
	echo "}" >> $@

.check-dep-pvtools: .detect-openssl.dep.c
	$(call check_dep, \
		"$(BIN_PROGRAM)", \
		$^, \
		"openssl-devel / libssl-dev version >= 1.1.1", \
		"HAVE_OPENSSL=0", \
		"-I.")
	$(call check_dep, \
		"$(BIN_PROGRAM)", \
		"curl/curl.h", \
		"libcurl-devel", \
		"HAVE_LIBCURL=0")
	touch $@

=== genprotimg/boot/Makefile ===
# Common definitions
include ../../common.mak

FILES := stage3a.bin stage3b.bin stage3b_reloc.bin
DEBUG_FILES := $(addsuffix .debug,$(FILES))

ifeq ($(HOST_ARCH),s390x)
ZIPL_DIR := $(rootdir)/zipl
ZIPL_BOOT_DIR := $(ZIPL_DIR)/boot
PKGDATADIR := $(DESTDIR)$(TOOLS_DATADIR)/genprotimg

INCLUDE_PATHS := $(ZIPL_BOOT_DIR) $(ZIPL_DIR)/include $(rootdir)/include
INCLUDE_PARMS := $(addprefix -I,$(INCLUDE_PATHS))

ALL_CFLAGS := $(NO_PIE_CFLAGS) -Os -g \
	$(INCLUDE_PARMS) \
	-DENABLE_SCLP_ASCII=1 \
	-DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
	-fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
	-fno-delete-null-pointer-checks -fno-stack-protector \
	-fexec-charset=IBM1047 -m64 -mpacked-stack \
	-mstack-size=4096 -mstack-guard=128 -msoft-float \
	-Wall -Wformat-security -Wextra \
	-Wno-array-bounds

ZIPL_SRCS_C := libc.c ebcdic.c ebcdic_conv.c sclp.c
ZIPL_SRCS_ASM := entry.S

ZIPL_OBJS_C := $(ZIPL_SRCS_C:%.c=%.o)
ZIPL_OBJS_ASM := $(ZIPL_SRCS_ASM:%.S=%.o)
ZIPL_OBJS := $(ZIPL_OBJS_C) $(ZIPL_OBJS_ASM)

# Prevent make from using some default rules...
%:	%.S

%.o:	%.S Makefile
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

%.o:	%.c Makefile
	$(CC) $(ALL_CFLAGS) -c -o $@ $<


# Dependencies for the .lds generation
sources_lds_S = $(wildcard *.lds.S)
dependencies_lds_S = $(sources_lds_S:%.lds.S=.%.lds.d)
# Include all ".lds.d" dependency files for all make targets except for "clean"
ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_lds_S)
endif

%.lds:	%.lds.S Makefile
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -P -C -o $@ $<

# Special rules for zipl object files
$(ZIPL_OBJS_C): %.o : $(ZIPL_BOOT_DIR)/%.c
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

$(ZIPL_OBJS_ASM): %.o : $(ZIPL_BOOT_DIR)/%.S
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

dependencies_zipl_c := $(ZIPL_SRCS_C:%.c=.%.o.d)

$(dependencies_zipl_c): .%.o.d : $(ZIPL_BOOT_DIR)/%.c
	$(CC_SILENT) -MM $(ALL_CPPFLAGS) $(ALL_CFLAGS) $< > $@

ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_zipl_c)
endif

stage3b_reloc.o: stage3b.bin

stage3a.elf: head.o stage3a_init.o $(ZIPL_OBJS)
stage3b.elf: head.o $(ZIPL_OBJS)

.SECONDARY: $(FILES:.bin=.lds)
%.elf: %.lds %.o
	$(LINK) $(NO_PIE_LDFLAGS) $(NO_WARN_RWX_SEGMENTS_LDFLAGS) -Wl,-T,$< -Wl,--build-id=none -m64 -static -nostdlib $(filter %.o, $^) -o $@
	@chmod a-x $@

%.bin.debug: %.elf
	$(OBJCOPY) --only-keep-debug $< $@

%.bin: %.elf
	$(OBJCOPY) -O binary $< $@
	@chmod a-x $@

install: stage3a.bin stage3b_reloc.bin
	$(INSTALL) -d -m 755 "$(PKGDATADIR)"
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 stage3a.bin "$(PKGDATADIR)"
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 stage3b_reloc.bin "$(PKGDATADIR)"

else
# Don't generate the dependency files (see `common.mak` for the
# `-include $(dependencies_c)` statement).
.PHONY: $(dependencies_c)

$(FILES) $(DEBUG_FILES):
	echo "  SKIP    $@ due to HOST_ARCH != s390x"

install:
	echo "  SKIP    Bootloader installation due to HOST_ARCH != s390x"
endif

.DEFAULT_GOAL := all
all: $(FILES) $(DEBUG_FILES)

clean:
	rm -f -- *.o *.elf *.bin *.map .*.d *.lds *.debug

.PHONY: all clean

=== zipl/boot/Makefile ===
# Common definitions
include ../../common.mak

INCLUDE_PATHS := $(rootdir)/zipl/include $(rootdir)/include
INCLUDE_PARMS := $(addprefix -I,$(INCLUDE_PATHS))

ALL_CFLAGS = $(NO_PIE_CFLAGS) -Os -g $(INCLUDE_PARMS) \
	  -DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
	  -fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
	  -fno-delete-null-pointer-checks -fno-stack-protector \
	  -fexec-charset=IBM1047 -m64 -mpacked-stack \
	  -mstack-size=4096 -mstack-guard=128 -msoft-float \
	  -W -Wall -Wformat-security -fno-sanitize=all -Wno-array-bounds
ALL_LDFLAGS += -fno-sanitize=all

INC_FILES := fba0.bin fba1b.bin fba2.bin \
	  eckd0_ldl.bin eckd0_cdl.bin \
	  eckd1.bin eckd1b.bin eckd2.bin \
	  tape0.bin \
	  eckd2dump_sv.bin tape2dump.bin fba2dump.bin eckd2dump_mv.bin
FILES := $(INC_FILES) stage3.bin
DEBUG_FILES := $(addsuffix .debug,$(FILES))

all: .loaders $(FILES) $(DEBUG_FILES)

.loaders: $(INC_FILES)
	touch .loaders

# Prevent make from using some default rules...
%:	%.S

%.o:	%.S
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

%.o:	%.c
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

# Dependencies for the .lds generation
sources_lds_S = $(wildcard *.lds.S)
dependencies_lds_S = $(sources_lds_S:%.lds.S=.%.lds.d)
# Include all ".lds.d" dependency files for all make targets except for "clean"
ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_lds_S)
endif

%.lds: %.lds.S
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -P -C -o $@ $<

fba0.exec eckd0_ldl.exec eckd0_cdl.exec tape0.exec: \
	stage0.lds

eckd1.exec: \
	stage1.lds

eckd1b.exec fba1b.exec: \
	stage1b.lds

eckd2dump_sv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_sv.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
eckd2dump_mv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_mv.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
fba2dump.exec: \
	head.o stage2dump.o cio.o fba2dump.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
tape2dump.exec: \
	head.o stage2dump.o cio.o tape2dump.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
eckd2.exec: head.o stage2.o cio.o eckd2.o libc.o ebcdic.o menu.o sclp.o \
	    kdump2.o kdump.o entry.o stage2.lds
fba2.exec: head.o stage2.o cio.o fba2.o libc.o ebcdic.o menu.o sclp.o \
	   kdump2.o kdump.o entry.o stage2.lds
stage3.exec: head.o stage3.o kdump3.o libc.o ebcdic.o ebcdic_conv.o sclp.o \
	     sclp_stage3.o kdump.o entry.o stage3.lds

%.exec:	%.o
	$(LINK) -Wl,-T,$(filter %.lds,$^) $(NO_PIE_LDFLAGS) $(NO_WARN_RWX_SEGMENTS_LDFLAGS) -Wl,--build-id=none -m64 -static -nostdlib $(filter %.o, $^) -o $@

%.bin.debug: %.exec
	$(OBJCOPY) --only-keep-debug $< $@

%.bin:	%.exec
	$(OBJCOPY) -O binary $< $@


clean:
	rm -f -- *.o *.exec *.bin *.lds .*.lds.d .loaders *.debug

.PHONY: all clean

=== zipl/src/Makefile ===
# Common definitions
include ../../common.mak

ALL_CPPFLAGS += -I../include -I../boot \
	    -DZFCPDUMP_IMAGE="STRINGIFY($(ZFCPDUMP_DIR)/$(ZFCPDUMP_IMAGE))" \
	    -DZFCPDUMP_INITRD="STRINGIFY($(ZFCPDUMP_DIR)/$(ZFCPDUMP_INITRD))" \
	    -D_FILE_OFFSET_BITS=64 -DBUILD_PATH="../boot"

libs =  $(rootdir)/libutil/libutil.a \
	$(rootdir)/libvtoc/libvtoc.a \

objects = misc.o error.o scan.o job.o boot.o bootmap.o fs-map.o disk.o \
	  bootmap_header.o envblk.o install.o zipl.o

zipl_helpers = $(basename $(wildcard zipl_helper.*.c))
chreipl_helpers = $(subst zipl_,chreipl_, $(zipl_helpers))
zipl_stage3 = ../boot/stage3.bin

all: zipl zipl-editenv $(chreipl_helpers) $(zipl_stage3)

boot.o: ../boot/.loaders
zipl: $(objects) $(libs)

zipl_helper.device-mapper: $(rootdir)/libdasd/libdasd.a \
	$(rootdir)/libvtoc/libvtoc.a \
	$(libs) zipl_helper.device-mapper.o

zipl-editenv: $(libs) misc.o error.o fs-map.o bootmap_header.o \
	envblk.o zipl-editenv.o

chreipl_helper.%: zipl_helper.%
	ln -f -s $< $@

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR)
	$(INSTALL) -c zipl $(DESTDIR)$(BINDIR)
	$(INSTALL) -c zipl-editenv $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 755 $(zipl_helpers) $(chreipl_helpers) \
		$(DESTDIR)$(TOOLS_LIBDIR)
	$(CP) --no-dereference $(chreipl_helpers) $(DESTDIR)$(TOOLS_LIBDIR)
	$(CP) --no-dereference $(zipl_stage3) $(DESTDIR)$(TOOLS_LIBDIR)

clean:
	rm -f *.o $(zipl_helpers) $(chreipl_helpers) zipl zipl-editenv

.PHONY: all install clean

# Additional manual dependencies

../boot/.loaders:
	$(MAKE) -C ../boot .loaders

../boot/stage3.bin:
	$(MAKE) -C ../boot stage3.bin

=== debian/changelog ===
s390-tools (2.29.0-0ubuntu2) mantic; urgency=medium

  * d/rules: Split the vendoring process into several discrete targets to be
    able to update the vendored code without having to update the tarball.
    This can be useful for security updates.
  * d/update-crate.sh: introduce a script to help updating a single crate
  * d/rules: don't overwrite the vendor tarball if it already exists. This
    should prevent some borked uploads.
  * d/README.source: Document the procedures for single-crate update as well
    as wholesale refresh of the vendor tarball.

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 20 Sep 2023 11:21:48 +0200

s390-tools (2.29.0-0ubuntu1) mantic; urgency=medium

  [ Frank Heimes ]
   * New upstream release, requested in LP: #2030316
     - Remove d/p/lp-2025578-Recursive-Makefiles-avoid-race-condition.patch
       since it's part of latest upstream version.
     - Adds KVM: Support AP Bindings in SE Header LP: #1983221
     - Adds Userspace Tool for IBK Request Generation and Insertion LP: #2003676
     - d/control: bumped Standards-Version version to 4.6.2.
     - d/s/lintian-overrides: Suppress lintian unknown-field(s)
       Build-Indep-Architecture and Vendored-Sources-Rust messages.
   * Update d/copyright and add. entries for the vendored crates.
   * Add pvsecret files to d/s390-tools.install.

  [ Simon Chopin ]
  * d/{rules,control}: Initial Rust packaging, including vendored sources.
  * Add d/p/rust_paths.patch to adapt upstream Rust Makefile for Debian's
    Rust tooling.
  * Add d/p/vendor-remove-unused-deps.patch to remove non relevant dependencies
    on some vendored crates.

 -- Frank Heimes <frank.heimes@canonical.com>  Sun, 06 Aug 2023 14:48:33 +0200

=== debian/control ===
Source: s390-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>
Build-Depends:
 bsdextrautils,
 debhelper-compat (= 13),
 dh-cargo,
 dh-exec,
 gcc-multilib [s390 s390x],
 libcryptsetup-dev,
 libcurl4-openssl-dev,
 libfuse3-dev,
 libglib2.0-dev,
 libjson-c-dev,
 liblockfile-dev,
 libncurses-dev,
 libpfm4-dev,
 libsnmp-dev,
 libssl-dev,
 libxml2-dev,
 libz-dev,
 pkg-config,
 quilt
Standards-Version: 4.6.2
Homepage: https://github.com/ibm-s390-linux/s390-tools
XS-Build-Indep-Architecture: s390x
XS-Vendored-Sources-Rust: anstream@0.3.2, anstyle-parse@0.2.0, anstyle-query@1.0.0, anstyle-wincon@1.0.1, anstyle@1.0.0, anyhow@1.0.71, autocfg@1.1.0, bitflags@1.3.2, byteorder@1.4.3, cc@1.0.79, cfg-if@1.0.0, clap@4.3.4, clap_builder@4.3.4, clap_derive@4.3.2, clap_lex@0.5.0, colorchoice@1.0.0, curl-sys@0.4.63+curl-8.1.2, curl@0.4.44, errno-dragonfly@0.1.2, errno@0.3.1, foreign-types-shared@0.1.1, foreign-types@0.3.2, hashbrown@0.12.3, heck@0.4.1, hermit-abi@0.3.1, indexmap@1.9.3, io-lifetimes@1.0.11, is-terminal@0.4.7, itoa@1.0.6, libc@0.2.146, libz-sys@1.1.9, linux-raw-sys@0.3.8, log@0.4.19, once_cell@1.18.0, openssl-macros@0.1.1, openssl-probe@0.1.5, openssl-sys@0.9.88, openssl@0.10.54, pkg-config@0.3.27, proc-macro2@1.0.60, quote@1.0.28, rustix@0.37.20, ryu@1.0.13, schannel@0.1.21, serde@1.0.164, serde_derive@1.0.164, serde_yaml@0.9.21, socket2@0.4.9, strsim@0.10.0, syn@1.0.109, syn@2.0.18, terminal_size@0.2.6, thiserror-impl@1.0.40, thiserror@1.0.40, unicode-ident@1.0.9, unsafe-libyaml@0.2.8, utf8parse@0.2.1, zerocopy-derive@0.3.2, zerocopy@0.6.1

Package: s390-tools
Architecture: s390 s390x amd64 ppc64el arm64
Priority: important
Depends:
 gawk [s390 s390x],
 s390-tools-data,
 udev [s390 s390x],
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
 ${signing:Depends}
Recommends: sg3-utils [s390 s390x]
Suggests:
 blktrace [s390 s390x],
 lsscsi [s390 s390x],
 mdevctl [s390 s390x],
 multipath-tools [s390 s390x],
 rsync [s390 s390x],
 s390-tools-chreipl-fcp-mpath [s390 s390x],
 s390-tools-cpuplugd [s390 s390x],
 s390-tools-osasnmpd [s390 s390x],
 s390-tools-statd [s390 s390x]
Description: fundamental utilities for Linux on z Systems
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.
  * hsavmcore, which is used to make the dump process with kdump more
    efficient.
  * lshwc, which is used to extract and list complete counter sets

Package: s390-tools-cpuplugd
Architecture: s390 s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: cpuplugd utility for Linux on z Systems
 The package contains cpuplugd hotplug daemon from the s390-tools
 collection of utilities.

Package: s390-tools-statd
Architecture: s390 s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: s390-tools (<<1.34.0-0ubuntu7~)
Replaces: s390-tools (<<1.34.0-0ubuntu7~)
Description: mon_statd monitoring daemons for Linux on z Systems
 The package contains mon_procd and mon_fsstatd z/VM monitoring
 daemons for Linux on z Systems from the s390-tools collection of
 utilities. These tools are also known as mon_statd.

Package: s390-tools-osasnmpd
Architecture: s390 s390x
Depends: udev, ${misc:Depends}, ${shlibs:Depends}
Description: osasnmpd utility for Linux on z Systems
 The package contains osasnmpd monitoring daemon from the s390-tools
 collection of utilities.

Package: s390-tools-zkey
Architecture: s390 s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zkey utilities for Linux on z Systems
 The package contains zkey and zkey-cryptsetup from the s390-tools
 collection of utilities.

Package: libekmfweb1
Architecture: s390 s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: integration with IBM Enterprise Key Management Foundation
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the runtime library.

Package: libekmfweb-dev
Architecture: s390 s390x
Depends: ${misc:Depends}
Description: integration with IBM Enterprise Key Management Foundation (development)
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the development library and headers.

Package: libkmipclient1
Architecture: s390 s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: KMIP client library
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the runtime library.

Package: libkmipclient-dev
Architecture: s390 s390x
Depends: ${misc:Depends}
Description: KMIP client library (development)
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the development library and headers

Package: s390-tools-chreipl-fcp-mpath
Architecture: s390 s390x
Depends: multipath-tools, multipath-tools-boot, udev, ${misc:Depends}
Description: chreipl-fcp-mpath utility for Linux on z Systems
 The package contains chreipl-fcp-mpath toolset from the s390-tools collection
 of utilities, that uses multipath information to change the configured FCP
 re-IPL path on detecting issues with the current path.

Package: s390-tools-data
Architecture: all
Depends: ${misc:Depends}
Replaces: s390-tools (<< 2.28.0-0ubuntu2)
Breaks: s390-tools (<< 2.28.0-0ubuntu2)
Description: fundamental utilities for Linux on z Systems (data files)
 Host architecture independent files used by s390-tools utilities for
 z Systems. Currently this package ships stage3a/b files for genprotimg.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = -D_GNU_SOURCE
export DEB_LDFLAGS_MAINT_APPEND=-rdynamic
export CARGO = /usr/share/cargo/bin/cargo
export CARGO_VENDOR_DIR = rust-vendor
export CARGO_HOME = $(CURDIR)/debian/cargo_home

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/rustc/architecture.mk
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE

ifeq ($(DEB_HOST_ARCH),s390x)
	options= V=1 HAVE_SNMP=1 SYSTEMDSYSTEMUNITDIR=/lib/systemd/system ZDEV_ALWAYS_UPDATE_INITRD=1 ZKEYKMSPLUGINDIR=/usr/libexec/zkey USRLIB64DIR=/usr/lib/s390x-linux-gnu
endif

# Enable signing in Launchpad only, and on s390x only
SIGN_SIPL=
ifeq ($(DEB_HOST_ARCH),s390x)
	ifneq (,$(wildcard /CurrentlyBuilding))
		SIGN_SIPL=yes
	endif
endif

VENDOR_TARBALL = s390-tools_$(DEB_VERSION_UPSTREAM).orig-$(CARGO_VENDOR_DIR).tar.xz

vendor-tarball-sanity-check:
	if [ -e ../$(VENDOR_TARBALL) ]; then echo "../$(VENDOR_TARBALL) already exists, bailing!"; exit 1; fi

vendor-deps:
	if QUILT_PATCHES=debian/patches quilt applied | grep vendor-remove-unused-deps ; then \
		echo "Detecting patch on vendor dir applied, aborting."; \
		exit 1; \
	fi
	rm -rf $(CARGO_VENDOR_DIR)
	# Deliberately don't use the wrapper, as it expects the configure step
	# to have occurred already.
	# If you have to modify the path here, don't forget to change the README.source doc
	# as well.
	cargo vendor --manifest-path rust/pvsecret/Cargo.toml $(CARGO_VENDOR_DIR)
	# Remove some crates that aren't useful for us and take up a lot of space
	rm -r \
		$(CARGO_VENDOR_DIR)/winapi \
		$(CARGO_VENDOR_DIR)/winapi-* \
		$(CARGO_VENDOR_DIR)/windows-* \
		$(CARGO_VENDOR_DIR)/windows_* \
		$(CARGO_VENDOR_DIR)/vcpkg
	# Remove the C sources from the binding crates, we're using the system libs
	rm -r \
		$(CARGO_VENDOR_DIR)/libz-sys/src/zlib \
		$(CARGO_VENDOR_DIR)/libz-sys/src/zlib-ng \
		$(CARGO_VENDOR_DIR)/curl-sys/curl
	# Remove the checksum files to allow us to patch the crates to remove extraneous dependencies
	for crate in $(CARGO_VENDOR_DIR)/*; do \
		sed -i 's/^{"files":.*"package":"\([a-z0-9]\+\)"}$$/{"files":{},"package":"\1"}/' $$crate/.cargo-checksum.json; \
	done
	# Cleanup temp files
	rm -rf $(CARGO_HOME)

vendor-tarball: vendor-tarball-sanity-check vendor-deps
	tar -caf ../$(VENDOR_TARBALL) $(CARGO_VENDOR_DIR)

%:
	dh $@

override_dh_auto_configure:
	DEB_CARGO_CRATE=s390-tools_$(shell dpkg-parsechangelog --show-field Version) \
	$(CARGO) prepare-debian $(CARGO_VENDOR_DIR)
	/usr/share/cargo/bin/dh-cargo-vendored-sources
	dh_auto_configure

override_dh_install:
ifeq ($(DEB_HOST_ARCH),s390x)
	# no dracut
	rm -f debian/tmp/lib/s390-tools/zdev-root-update
	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump-initrd
	dh_install -ps390-tools-cpuplugd
	dh_install -ps390-tools-statd
	dh_install -ps390-tools-osasnmpd
	dh_install -ps390-tools-zkey
	dh_install -ps390-tools-chreipl-fcp-mpath
	dh_install -ps390-tools-data
	dh_install $(if $(SIGN_SIPL),-Xstage3.bin) -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd -X60-readahead.rules -Xzkey -Xchreipl-fcp-mpath -Xdata -Xstage3a.bin -Xstage3b_reloc.bin
	$(if $(SIGN_SIPL),echo 'signing:Depends=s390-tools-signed (= $(DEB_VERSION))') >> debian/s390-tools.substvars
else
	dh_install -Xstage3a.bin -Xstage3b_reloc.bin
endif

override_dh_fixperms:
	dh_fixperms
ifeq ($(DEB_HOST_ARCH),s390x)
	chmod 644 debian/s390-tools-zkey/usr/libexec/zkey/zkey-ekmfweb.so
	chmod 644 debian/s390-tools-zkey/usr/libexec/zkey/zkey-kmip.so
endif

override_dh_auto_clean:
	rm -f zipl/boot/.*.d
	dh_auto_clean -- $(options)

override_dh_auto_build:
	dh_auto_build -- $(options)

override_dh_auto_install:
	HAVE_INITRAMFS=1 HAVE_DRACUT=1 dh_auto_install -- $(options)

signing=debian/s390-tools-$(DEB_VERSION)-signing/
signingv=$(signing)/$(DEB_VERSION)
signing_tar=$(DEB_SOURCE)_$(DEB_VERSION)_$(DEB_HOST_ARCH).tar.gz
override_dh_builddeb:
	dh_builddeb
ifeq ($(DEB_HOST_ARCH),s390x)
	mkdir -p $(signingv)/control
	echo 'tarball' >$(signingv)/control/options
	cp debian/tmp/lib/s390-tools/stage3.bin $(signingv)/stage3.bin.sipl
	tar -C $(signing) -czvf $(CURDIR)/../$(signing_tar) .
	dpkg-distaddfile $(signing_tar) raw-signing -
endif
override_dh_clean:
	dh_clean
	rm -rf $(CARGO_HOME)
	rm -rf $(signing)

## s390-tools 2.30.0

=== rust/Makefile ===
--- 
+++ 
@@ -15,16 +15,17 @@
 
 	BUILD_TARGETS = $(CARGO_TARGETS)
 	INSTALL_TARGETS := install-rust-tools install-man
-	CARGO_TEST_TARGETS = $(addsuffix, _test, $(CARGO_TARGETS))
+	CARGO_TEST_TARGETS = $(addsuffix .test, $(CARGO_TARGETS))
 
 ifneq (${HAVE_OPENSSL},0)
 ifneq (${HAVE_LIBCURL},0)
 	PV_TARGETS := pvsecret
 
-	PV_BUILD_TARGETS = $(PV_TARGETS)
-	CARGO_TEST_TARGETS += $(addsuffix, _test, $(PV_TARGETS)) pv
+	PV_BUILD_TARGETS := $(PV_TARGETS)
+	CARGO_TEST_TARGETS += $(addsuffix .test,pv $(PV_TARGETS))
 endif #LIBCURL
 endif #OPENSSL
+	TEST_TARGETS := $(addsuffix _build,$(CARGO_TEST_TARGETS))
 endif #CARGO
 
 BUILD_TARGETS += $(PV_BUILD_TARGETS)
@@ -39,18 +40,15 @@
 $(BUILD_TARGETS) rust-test: CC = $(CC_SILENT)
 $(BUILD_TARGETS) rust-test: AR = $(AR_SILENT)
 
-$(CARGO_TARGETS): .check-cargo .no-cross-compile
-	$(CARGO_BUILD) --manifest-path=$@/Cargo.toml $(ALL_CARGOFLAGS)
-.PHONY: $(CARGO_TARGETS)
+$(PV_TARGETS): .check-dep-pvtools
+$(PV_TARGETS) $(CARGO_TARGETS): .check-cargo .no-cross-compile
+	$(CARGO_BUILD) --bin $@ $(ALL_CARGOFLAGS)
+.PHONY: $(PV_TARGETS) $(CARGO_TARGETS)
 
-
-$(CARGO_TEST_TARGETS): .check-cargo .no-cross-compile
-	$(CARGO_TEST) --manifest-path=$@/Cargo.toml --all-features $(CARGOFLAGS)
-.PHONY: $(CARGO_TEST_TARGETS)
-
-$(PV_TARGETS): .check-cargo .no-cross-compile .check-dep-pvtools
-	$(CARGO_BUILD) --manifest-path=$@/Cargo.toml $(ALL_CARGOFLAGS)
-.PHONY: $(PV_TARGETS)
+$(TEST_TARGETS): ALL_CARGOFLAGS += --no-run
+$(CARGO_TEST_TARGETS) $(TEST_TARGETS): .check-cargo .no-cross-compile
+	$(CARGO_TEST) --package $(basename $@) --all-features $(ALL_CARGOFLAGS)
+.PHONY: $(TEST_TARGETS) $(CARGO_TEST_TARGETS)
 
 skip-build:
 	echo "  SKIP    rust-tools due to unresolved dependencies"
@@ -65,22 +63,17 @@
 	echo $(BUILD_TARGETS)
 
 clean:
-	$(foreach target,$(CARGO_TARGETS),\
-		$(CARGO_CLEAN) --manifest-path=$(target)/Cargo.toml ${ALL_CARGOFLAGS} ;)
-	$(foreach target,$(PV_TARGETS),\
-		$(CARGO_CLEAN) --manifest-path=$(target)/Cargo.toml ${CARGOFLAGS} ;)
+	$(CARGO_CLEAN) ${ALL_CARGOFLAGS}
 	$(RM) -- .check-dep-pvtools .detect-openssl.dep.c .check-cargo
 
-rust-test: .check-cargo .no-cross-compile
-	$(foreach target,$(CARGO_TEST_TARGETS),\
-		$(CARGO_TEST) --manifest-path=$(target)/Cargo.toml --all-features ${ALL_CARGOFLAGS} ;)
+rust-test: $(CARGO_TEST_TARGETS)
 
 install-rust-tools: $(BUILD_TARGETS)
 	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
 	$(foreach target,$(CARGO_TARGETS),\
-		$(INSTALL) $(target)/target/release/$(target) $(DESTDIR)$(USRBINDIR);)
+		$(INSTALL) target/release/$(target) $(DESTDIR)$(USRBINDIR);)
 	$(foreach target,$(PV_TARGETS),\
-		$(INSTALL) $(target)/target/release/$(target) $(DESTDIR)$(USRBINDIR);)
+		$(INSTALL) target/release/$(target) $(DESTDIR)$(USRBINDIR);)
 
 install-man:
 	$(foreach target,$(CARGO_TARGETS),\
@@ -118,13 +111,13 @@
 
 .check-dep-pvtools: .detect-openssl.dep.c
 	$(call check_dep, \
-		"$(BIN_PROGRAM)", \
+		"Rust-pv", \
 		$^, \
 		"openssl-devel / libssl-dev version >= 1.1.1", \
 		"HAVE_OPENSSL=0", \
 		"-I.")
 	$(call check_dep, \
-		"$(BIN_PROGRAM)", \
+		"Rust-pv", \
 		"curl/curl.h", \
 		"libcurl-devel", \
 		"HAVE_LIBCURL=0")

=== debian/changelog ===
s390-tools (2.30.0-0ubuntu1) noble; urgency=medium

  * Remove some unused test directories from vendored dependencies to
    reduce the overall size of the vendor tarball

  [ Frank Heimes ]
  * New upstream release, requested in LP: #2045953
    - Remove d/p/lp-2028936-zkey-Support-EP11-AES-keys-with-prepended-.patch
      since it's now incl. in upstream 2.30.0.
    - Adjust d/p/rust_path.patch to align with changes in Makefile.
    - Adjust d/update-crate.sh and d/rules and point to the new workspace.
    - Due to the updated mockito crate 1.0, the entire tokio runtime is pulled
      in (needed for testing), which increases the vendored crate tar ball size
      to 5.5MB.
    - Update and expand d/vendor-remove-unused-deps.patch due to context changes
      in Cargo.toml files and because additional crates were added.
    - Update XS-Vendored-Sources-Rust field in d/control.
    - Adjust d/rules to not remove $(CARGO_VENDOR_DIR)/vcpkg,
      to fix a build issue.

 -- Simon Chopin <schopin@ubuntu.com>  Tue, 16 Jan 2024 11:58:42 +0100

s390-tools (2.29.0-0ubuntu3) noble; urgency=medium

  * Change zkey to generate EP11 keys using a new format (PKEY_TYPE_EP11_AES),
    that allows to keep support for existing key blobs by adding d/p/
    lp-2028936-zkey-Support-EP11-AES-keys-with-prepended-header-to-.patch
    (LP: #2028936)

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 28 Nov 2023 12:00:58 +0100

=== debian/control ===
--- 
+++ 
@@ -27,7 +27,7 @@
 Standards-Version: 4.6.2
 Homepage: https://github.com/ibm-s390-linux/s390-tools
 XS-Build-Indep-Architecture: s390x
-XS-Vendored-Sources-Rust: anstream@0.3.2, anstyle-parse@0.2.0, anstyle-query@1.0.0, anstyle-wincon@1.0.1, anstyle@1.0.0, anyhow@1.0.71, autocfg@1.1.0, bitflags@1.3.2, byteorder@1.4.3, cc@1.0.79, cfg-if@1.0.0, clap@4.3.4, clap_builder@4.3.4, clap_derive@4.3.2, clap_lex@0.5.0, colorchoice@1.0.0, curl-sys@0.4.63+curl-8.1.2, curl@0.4.44, errno-dragonfly@0.1.2, errno@0.3.1, foreign-types-shared@0.1.1, foreign-types@0.3.2, hashbrown@0.12.3, heck@0.4.1, hermit-abi@0.3.1, indexmap@1.9.3, io-lifetimes@1.0.11, is-terminal@0.4.7, itoa@1.0.6, libc@0.2.146, libz-sys@1.1.9, linux-raw-sys@0.3.8, log@0.4.19, once_cell@1.18.0, openssl-macros@0.1.1, openssl-probe@0.1.5, openssl-sys@0.9.88, openssl@0.10.54, pkg-config@0.3.27, proc-macro2@1.0.60, quote@1.0.28, rustix@0.37.20, ryu@1.0.13, schannel@0.1.21, serde@1.0.164, serde_derive@1.0.164, serde_yaml@0.9.21, socket2@0.4.9, strsim@0.10.0, syn@1.0.109, syn@2.0.18, terminal_size@0.2.6, thiserror-impl@1.0.40, thiserror@1.0.40, unicode-ident@1.0.9, unsafe-libyaml@0.2.8, utf8parse@0.2.1, zerocopy-derive@0.3.2, zerocopy@0.6.1
+XS-Vendored-Sources-Rust: addr2line@0.21.0, adler@1.0.2, aho-corasick@1.1.2, anstream@0.3.2, anstyle-parse@0.2.0, anstyle-query@1.0.0, anstyle-wincon@1.0.1, anstyle@1.0.0, anyhow@1.0.71, assert-json-diff@2.0.2, autocfg@1.1.0, backtrace@0.3.69, bitflags@1.3.2, bitflags@2.4.1, byteorder@1.4.3, bytes@1.5.0, cc@1.0.79, cfg-if@1.0.0, clap@4.3.4, clap_builder@4.3.4, clap_derive@4.3.2, clap_lex@0.5.0, colorchoice@1.0.0, curl-sys@0.4.68+curl-8.4.0, curl@0.4.44, equivalent@1.0.1, errno-dragonfly@0.1.2, errno@0.3.1, fnv@1.0.7, foreign-types-shared@0.1.1, foreign-types@0.3.2, form_urlencoded@1.2.0, futures-channel@0.3.29, futures-core@0.3.29, futures-executor@0.3.29, futures-io@0.3.29, futures-macro@0.3.29, futures-sink@0.3.29, futures-task@0.3.29, futures-util@0.3.29, futures@0.3.29, getrandom@0.2.10, gimli@0.28.1, h2@0.3.22, hashbrown@0.12.3, hashbrown@0.14.3, heck@0.4.1, hermit-abi@0.3.1, http-body@0.4.5, http@0.2.11, httparse@1.8.0, httpdate@1.0.3, hyper@0.14.27, indexmap@1.9.3, indexmap@2.1.0, io-lifetimes@1.0.11, is-terminal@0.4.7, itoa@1.0.6, lazy_static@1.4.0, libc@0.2.146, libz-sys@1.1.9, linux-raw-sys@0.3.8, lock_api@0.4.11, log@0.4.19, memchr@2.6.4, miniz_oxide@0.7.1, mio@0.8.8, mockito@1.2.0, num_cpus@1.16.0, object@0.32.1, once_cell@1.18.0, openssl-macros@0.1.1, openssl-probe@0.1.5, openssl-sys@0.9.96, openssl@0.10.60, parking_lot@0.12.1, parking_lot_core@0.9.9, percent-encoding@2.3.0, pin-project-lite@0.2.13, pin-utils@0.1.0, pkg-config@0.3.27, ppv-lite86@0.2.17, proc-macro2@1.0.60, quote@1.0.28, rand@0.8.5, rand_chacha@0.3.1, rand_core@0.6.4, redox_syscall@0.4.1, regex-automata@0.4.3, regex-syntax@0.8.2, regex@1.10.2, rustc-demangle@0.1.23, rustix@0.37.27, ryu@1.0.13, schannel@0.1.21, scopeguard@1.2.0, serde@1.0.164, serde_derive@1.0.164, serde_json@1.0.99, serde_test@1.0.176, serde_urlencoded@0.7.1, serde_yaml@0.9.21, signal-hook-registry@1.4.1, similar@2.3.0, slab@0.4.9, smallvec@1.11.2, socket2@0.4.9, socket2@0.5.4, strsim@0.10.0, syn@1.0.109, syn@2.0.18, terminal_size@0.2.6, thiserror-impl@1.0.40, thiserror@1.0.40, tokio-macros@2.1.0, tokio-util@0.7.10, tokio@1.33.0, tower-service@0.3.2, tracing-core@0.1.32, tracing@0.1.40, try-lock@0.2.4, unicode-ident@1.0.9, unsafe-libyaml@0.2.8, utf8parse@0.2.1, vcpkg@0.2.15, want@0.3.1, wasi@0.11.0+wasi-snapshot-preview1, zerocopy-derive@0.3.2, zerocopy@0.6.1
 
 Package: s390-tools
 Architecture: s390 s390x amd64 ppc64el arm64
